(function($) {
  $(document).ready(function() {
    // Enable popovers everywhere.
    $('[data-toggle="popover"]').popover();
    // Enable tooltips everywhere.
    $('[data-toggle="tooltip"]').tooltip();
    // Sidebar toggles
    $('.toggle-sidebar').click(function (e) {
      $('.main-sidebar').toggleClass('open');
    });
    // Accordion animations
    $(".obs-values").on('show.bs.collapse', function() {
      $(this).prev(".list-group-item").find(".fa").removeClass("fa-plus-square").addClass("fa-caret-square-up");
      setTimeout(function(el){ explorer.colorize(el); }, 100, this); // Defer to improve UX
    }).on('shown.bs.collapse', function() {
      // $('.main-sidebar .nav-wrapper').animate({
      //     scrollTop: $(this).prev(".list-group-item").position().top - 61
      // }, 500, "swing");
    }).on('hide.bs.collapse', function() {
      $(this).prev(".list-group-item").find(".fa").removeClass("fa-caret-square-up").addClass("fa-plus-square");
    });
    // Init cell atlas explorer
    if ($("#canvas-container").length) {
      var explorer = $("#canvas-container").explorer();
      // Add events
      $(".colourise").on('click', function(event){
        if (explorer) {
          explorer.colorize(this);
          let genes = document.querySelector('#genes');
          genes.deselect(genes.selectedItems[0]);
        }
      });
      $("#genes").on("update", function(event) {
        if (this.selectedItems[0] && this.selectedItems[0] != $("#color-scale-value").text() && explorer) explorer.colorize(this);
      });
      $(".btn-gene-select").on('click', function(event){
        if ($(this).text() != $("#color-scale-value").text() && explorer) explorer.colorize(this);
      });      
      $('.obs_value_cb').click(function(event) {
        setTimeout(function(){ explorer.redraw(); }, 100); // Defer to improve UX
      });
      $(".checkall").click(function(event) {
        $('#collapse' + $(this).data('id')).find('input[type=checkbox]').prop('checked', true);
        setTimeout(function(){ explorer.redraw(); }, 100); // Defer to improve UX
      });
      $(".uncheckall").click(function(event) {
        $('#collapse' + $(this).data('id')).find('input[type=checkbox]').prop('checked', false);
        setTimeout(function(){ explorer.redraw(); }, 100); // Defer to improve UX
      });
      $("#color-scale-remove").click(function(event) {
        explorer.removeColor(this) 
      });
      $('body').on('click', '.canvas-obsm-key', function(event) {
        explorer.embedding(this) 
      });
      $("#canvas-zoom-reset").click(function(event) {
        explorer.resetZoom(this) 
      });
      $("#canvas-zoom-plus").click(function(event) {
        explorer.zoomIn(this) 
      });
      $("#canvas-zoom-minus").click(function(event) {
        explorer.zoomOut(this) 
      });      
    } 

    $("#chosen-remote-multiple").chosen();
    $("#chosen-remote-single").chosen();
    $(".chosen-search").find("input").attr("readonly", false);;
  });

  $('#chosen-remote-multiple').on('chosen:showing_dropdown', function(evt, params) {
      $(".chosen-multiple").find(".chosen-results").find(".active-result").remove();
  });

  $('#chosen-remote-single').on('chosen:showing_dropdown', function(evt, params) {
      $(".chosen-single").find(".chosen-results").find(".active-result").remove();
  });


  var remoteSearchFunctionMultiple = debounce(function() {
      var searchValue = $(".chosen-multiple").find(".chosen-search-input").val()
      $.ajax({
          url: "https://api.github.com/search/users",
          method:"get",
          data:{
              q : searchValue
          }
      }).done(function(response) {
          var optionsHtmlString = "";
          response.items.forEach(function(item, index){
              optionsHtmlString += "<option value=" + item.login + ">" + item.login + "</option>"
          });
          $("#chosen-remote-multiple").append(optionsHtmlString);
          $("#chosen-remote-multiple").trigger("chosen:updated");
      });
  }, 500);

  var remoteSearchFunctionSingle = debounce(function() {
      var searchValue = $(".chosen-single").find(".chosen-search-input").val()
      $.ajax({
          url: "https://api.github.com/search/users",
          method:"get",
          data:{
              q : searchValue
          }
      }).done(function(response) {
          var optionsHtmlString = "";
          response.items.forEach(function(item, index){
              optionsHtmlString += "<option value=" + item.login + ">" + item.login + "</option>"
          });
          $("#chosen-remote-single").append(optionsHtmlString);
          $("#chosen-remote-single").trigger("chosen:updated");
      });
  }, 500);


  function debounce(func, wait, immediate) {
    var timeout;
    return function() {
      var context = this, args = arguments;
      var later = function() {
        timeout = null;
        if (!immediate) func.apply(context, args);
      };
      var callNow = immediate && !timeout;
      clearTimeout(timeout);
      timeout = setTimeout(later, wait);
      if (callNow) func.apply(context, args);
    };
  };

  $(".chosen-multiple").on("keyup",".chosen-search-input", remoteSearchFunctionMultiple);
  $(".chosen-single").on("keyup",".chosen-search-input", remoteSearchFunctionSingle);  
})(jQuery);
